'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GridCell = exports.GridRow = exports.GridHead = exports.GridBody = exports.Grid = exports.GridCellAlignment = exports.GRID = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _prefix = require('@devexperts/utils/lib/dom/prefix');

var _prefix2 = _interopRequireDefault(_prefix);

var _pure = require('../../utils/pure');

var _Pure = require('../Pure/Pure');

var _Table = require('../Table/Table');

var _Emitter2 = require('@devexperts/utils/lib/emitter/Emitter');

var _Emitter3 = _interopRequireDefault(_Emitter2);

var _Scrollable = require('../Scrollable/Scrollable');

var _classnames4 = require('classnames');

var _classnames5 = _interopRequireDefault(_classnames4);

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GRID = exports.GRID = Symbol('Grid');
var EVENT_GRID = {
    BODY_SCROLL: 'EVENT_GRID:BODY_SCROLL',
    BODY_SCROLLBAR_APPEAR: 'EVENT_GRID:BODU_SCROLLBAR_APPER',
    CELL_MOUNT: 'EVENT_GRID:CELL_MOUNT',
    CELL_UPDATE: 'EVENT_GRID:CELL_UPDATE',
    GRID_MOUNT: 'EVENT_GRID:GRID_MOUNT',
    GRID_UPDATE: 'EVENT_GRID:GRID_UPDATE'
};

var GridInternalEmitter = function (_Emitter) {
    _inherits(GridInternalEmitter, _Emitter);

    function GridInternalEmitter() {
        _classCallCheck(this, GridInternalEmitter);

        return _possibleConstructorReturn(this, (GridInternalEmitter.__proto__ || Object.getPrototypeOf(GridInternalEmitter)).apply(this, arguments));
    }

    _createClass(GridInternalEmitter, [{
        key: 'emit',
        value: function emit(event) {
            for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = arguments[_key];
            }

            this._emit.apply(this, [event].concat(args));
        }
    }]);

    return GridInternalEmitter;
}(_Emitter3.default);

var GRID_CONTEXT_EMITTER = '__GRID_CONTEXT_EMITTER__';
var CONTEXT_TYPES = _defineProperty({}, GRID_CONTEXT_EMITTER, PropTypes.instanceOf(GridInternalEmitter).isRequired);
var RawGrid = function (_React$Component) {
    _inherits(RawGrid, _React$Component);

    function RawGrid() {
        _classCallCheck(this, RawGrid);

        var _this2 = _possibleConstructorReturn(this, (RawGrid.__proto__ || Object.getPrototypeOf(RawGrid)).apply(this, arguments));

        _this2._rows = {
            head: {},
            body: {}
        };
        _this2._maxColumnWidths = {};
        _this2.onCellMount = function (rowIndex, columnIndex, width, isInHead) {
            var rowStorage = isInHead ? _this2._rows.head : _this2._rows.body;
            //set or update row storage
            if (!rowStorage[rowIndex]) {
                rowStorage[rowIndex] = {
                    columns: {}
                };
            }
            rowStorage[rowIndex].columns[columnIndex] = width;
            //detect max width
            var maxColumnWidthByIndex = _this2._maxColumnWidths[columnIndex];
            if (!maxColumnWidthByIndex || maxColumnWidthByIndex && maxColumnWidthByIndex < width) {
                _this2._maxColumnWidths[columnIndex] = width;
            }
        };
        _this2.onCellRemount = function () {
            throw new Error('Grid does not support dynamic row/cell mounts');
        };
        _this2.onCellUpdate = function (rowIndex, columnIndex, newWidth, isInHead) {
            //update row storage
            var rowStorage = isInHead ? _this2._rows.head : _this2._rows.body;
            rowStorage[rowIndex].columns[columnIndex] = newWidth;
            //update max width
            _this2._maxColumnWidths[columnIndex] = Math.max.apply(Math, _toConsumableArray(Object.keys(_this2._rows.head).map(function (key) {
                return _this2._rows.head[key].columns[columnIndex];
            })).concat(_toConsumableArray(Object.keys(_this2._rows.body).map(function (key) {
                return _this2._rows.body[key].columns[columnIndex];
            }))));
        };
        return _this2;
    }

    _createClass(RawGrid, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return _defineProperty({}, GRID_CONTEXT_EMITTER, this._emitter);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._emitter.emit(EVENT_GRID.GRID_MOUNT, this._maxColumnWidths);
            this._emitter.off(EVENT_GRID.CELL_MOUNT, this.onCellMount);
            this._emitter.on(EVENT_GRID.CELL_MOUNT, this.onCellRemount);
            //start listening to cell updates
            this._emitter.on(EVENT_GRID.CELL_UPDATE, this.onCellUpdate);
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._emitter = new GridInternalEmitter();
            this._emitter.on(EVENT_GRID.CELL_MOUNT, this.onCellMount);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._emitter.off(EVENT_GRID.CELL_MOUNT, this.onCellRemount);
            this._emitter.off(EVENT_GRID.CELL_UPDATE, this.onCellUpdate);
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            //this is called after all cells updated
            //notify head
            this._emitter.emit(EVENT_GRID.GRID_UPDATE, this._maxColumnWidths);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                theme = _props.theme,
                children = _props.children;

            return _react2.default.createElement("div", { className: theme.container }, children);
        }
    }]);

    return RawGrid;
}(_react2.default.Component);
RawGrid.childContextTypes = CONTEXT_TYPES;
RawGrid = tslib_1.__decorate([_pure.PURE
// @themr(GRID)

// @themr(GRID)

// @themr(GRID)
], RawGrid);
var RawGridHead = function (_React$Component2) {
    _inherits(RawGridHead, _React$Component2);

    function RawGridHead() {
        _classCallCheck(this, RawGridHead);

        var _this3 = _possibleConstructorReturn(this, (RawGridHead.__proto__ || Object.getPrototypeOf(RawGridHead)).apply(this, arguments));

        _this3.state = {
            scrollLeft: 0,
            withVerticalScrollbar: false,
            columns: {}
        };
        _this3.onGridBodyScroll = function (scrollLeft, scrollTop) {
            _this3.setState({
                scrollLeft: scrollLeft
            });
        };
        _this3.onGridBodyScrollbarAppear = function (withHorizontalScrollbar, withVerticalScrollbar) {
            _this3.setState({
                withHorizontalScrollbar: withHorizontalScrollbar,
                withVerticalScrollbar: withVerticalScrollbar
            });
        };
        _this3.onGridMount = function (columns) {
            _this3.setState({
                columns: Object.assign({}, columns)
            });
        };
        return _this3;
    }

    _createClass(RawGridHead, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var emitter = this.context[GRID_CONTEXT_EMITTER];
            emitter.on(EVENT_GRID.BODY_SCROLL, this.onGridBodyScroll);
            emitter.on(EVENT_GRID.BODY_SCROLLBAR_APPEAR, this.onGridBodyScrollbarAppear);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var emitter = this.context[GRID_CONTEXT_EMITTER];
            emitter.off(EVENT_GRID.BODY_SCROLL, this.onGridBodyScroll);
            emitter.off(EVENT_GRID.BODY_SCROLLBAR_APPEAR, this.onGridBodyScrollbarAppear);
        }
    }, {
        key: 'render',
        value: function render() {
            var _a = this.props,
                _a$Table = _a.Table,
                Table = _a$Table === undefined ? _Table.Table : _a$Table,
                theme = _a.theme,
                _a$TableHead = _a.TableHead,
                TableHead = _a$TableHead === undefined ? _Table.TableHead : _a$TableHead,
                props = tslib_1.__rest(_a, ["Table", "theme", "TableHead"]);var _state = this.state,
                scrollLeft = _state.scrollLeft,
                withVerticalScrollbar = _state.withVerticalScrollbar;

            var style = void 0;
            if (typeof scrollLeft !== 'undefined') {
                style = (0, _prefix2.default)({
                    transform: 'translateX(-' + scrollLeft + 'px)'
                });
            }
            var className = (0, _classnames5.default)(theme.gridHead, _defineProperty({}, theme.gridHead_paddedForScrollbar, withVerticalScrollbar));
            //todo support multiple rows in head
            return _react2.default.createElement("div", { className: className }, _react2.default.createElement("div", { className: theme.gridHead__content, style: style }, _react2.default.createElement(_Pure.Pure, Object.assign({}, this.props, { check: this.state.columns, check2: props.children }), function () {
                return _react2.default.createElement(Table, { theme: theme }, _react2.default.createElement(TableHead, Object.assign({ theme: theme }, props), _react2.default.Children.only(props.children)));
            })));
        }
    }]);

    return RawGridHead;
}(_react2.default.Component);
RawGridHead.contextTypes = CONTEXT_TYPES;
RawGridHead = tslib_1.__decorate([_pure.PURE], RawGridHead);
var RawGridBody =
// @themr(GRID)
function (_React$Component3) {
    _inherits(RawGridBody, _React$Component3);

    function RawGridBody() {
        _classCallCheck(this, RawGridBody);

        var _this4 = _possibleConstructorReturn(this, (RawGridBody.__proto__ || Object.getPrototypeOf(RawGridBody)).apply(this, arguments));

        _this4.onScroll = function (scrollLeft, scrollTop) {
            if (_this4._scrollLeft !== scrollLeft) {
                _this4._scrollLeft = scrollLeft;
                _this4.context[GRID_CONTEXT_EMITTER].emit(EVENT_GRID.BODY_SCROLL, scrollLeft, scrollTop);
            }
        };
        _this4.onUpdate = function (withHorizontalScrollbar, withVerticalScrollbar) {
            if (_this4._withHorizontalScrollbar !== withHorizontalScrollbar || _this4._withVerticalScrollbar !== withVerticalScrollbar) {
                _this4._withVerticalScrollbar = withVerticalScrollbar;
                _this4._withHorizontalScrollbar = withHorizontalScrollbar;
                _this4.context[GRID_CONTEXT_EMITTER].emit(EVENT_GRID.BODY_SCROLLBAR_APPEAR, withHorizontalScrollbar, withVerticalScrollbar);
            }
        };
        return _this4;
    }

    _createClass(RawGridBody, [{
        key: 'render',
        value: function render() {
            var _a = this.props,
                _a$Table2 = _a.Table,
                Table = _a$Table2 === undefined ? _Table.Table : _a$Table2,
                _a$TableBody = _a.TableBody,
                TableBody = _a$TableBody === undefined ? _Table.TableBody : _a$TableBody,
                theme = _a.theme,
                props = tslib_1.__rest(_a, ["Table", "TableBody", "theme"]);
            var scrollableTheme = {
                horizontal_scrollbar__bar: theme.horizontal_scrollbar__bar,
                vertical_scrollbar__bar: theme.vertical_scrollbar__bar,
                container: undefined
            };
            return _react2.default.createElement(_Scrollable.Scrollable, { onScroll: this.onScroll, onUpdate: this.onUpdate, theme: scrollableTheme }, _react2.default.createElement("div", { className: theme.gridBody }, _react2.default.createElement(Table, { theme: theme }, _react2.default.createElement(TableBody, Object.assign({ theme: theme }, props), _react2.default.Children.map(props.children, function (child, i) {
                return _react2.default.cloneElement(child, {
                    gridRowIndexKey: i
                });
            })))));
        }
    }]);

    return RawGridBody;
}(_react2.default.Component);
RawGridBody.contextTypes = CONTEXT_TYPES;
RawGridBody = tslib_1.__decorate([_pure.PURE], RawGridBody);
var RawGridRow =
// @themr(GRID)
function (_React$Component4) {
    _inherits(RawGridRow, _React$Component4);

    function RawGridRow() {
        _classCallCheck(this, RawGridRow);

        var _this5 = _possibleConstructorReturn(this, (RawGridRow.__proto__ || Object.getPrototypeOf(RawGridRow)).apply(this, arguments));

        _this5.state = {
            columns: {}
        };
        _this5.onGridMount = function (columns) {
            _this5.setState({
                columns: Object.assign({}, columns)
            });
        };
        _this5.onGridUpdate = function (columns) {
            _this5.setState({
                columns: Object.assign({}, columns)
            });
        };
        return _this5;
    }

    _createClass(RawGridRow, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var emitter = this.context[GRID_CONTEXT_EMITTER];
            emitter.on(EVENT_GRID.GRID_MOUNT, this.onGridMount);
            emitter.on(EVENT_GRID.GRID_UPDATE, this.onGridUpdate);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var emitter = this.context[GRID_CONTEXT_EMITTER];
            emitter.on(EVENT_GRID.GRID_MOUNT, this.onGridMount);
            emitter.on(EVENT_GRID.GRID_UPDATE, this.onGridUpdate);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this6 = this;

            var _a = this.props,
                _a$TableRow = _a.TableRow,
                TableRow = _a$TableRow === undefined ? _Table.TableRow : _a$TableRow,
                props = tslib_1.__rest(_a, ["TableRow"]);
            var rowIndex = this.props.gridRowIndexKey;
            return _react2.default.createElement(TableRow, Object.assign({}, props), _react2.default.Children.map(this.props.children, function (child, i) {
                var newProps = {
                    gridRowIndexKey: rowIndex,
                    gridColumnIndexKey: i
                };
                if (_this6.state.columns) {
                    newProps.gridColumnWidth = _this6.state.columns[i];
                }
                return _react2.default.cloneElement(child, newProps); //dont forget
            }));
        }
    }]);

    return RawGridRow;
}(_react2.default.Component);
RawGridRow.contextTypes = CONTEXT_TYPES;
RawGridRow = tslib_1.__decorate([_pure.PURE], RawGridRow);
/**
 * @enum
 */
var GridCellAlignment = exports.GridCellAlignment = undefined;
(function (GridCellAlignment) {
    GridCellAlignment["LEFT"] = "GRID_CELL_ALIGN:LEFT";
    GridCellAlignment["CENTER"] = "GRID_CELL_ALIGN:CENTER";
    GridCellAlignment["RIGHT"] = "GRID_CELL_ALIGN:RIGHT";
})(GridCellAlignment || (exports.GridCellAlignment = GridCellAlignment = {}));
;
var RawGridCell =
// @themr(GRID)
function (_React$Component5) {
    _inherits(RawGridCell, _React$Component5);

    function RawGridCell() {
        _classCallCheck(this, RawGridCell);

        return _possibleConstructorReturn(this, (RawGridCell.__proto__ || Object.getPrototypeOf(RawGridCell)).apply(this, arguments));
    }

    _createClass(RawGridCell, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._width = _reactDom2.default.findDOMNode(this._content).clientWidth;
            var emitter = this.context[GRID_CONTEXT_EMITTER];
            emitter.emit(EVENT_GRID.CELL_MOUNT, this.props.gridRowIndexKey, this.props.gridColumnIndexKey, this._width, this.props.isInHead);
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var newWidth = _reactDom2.default.findDOMNode(this._content).clientWidth;
            if (newWidth !== this._width) {
                this._width = newWidth;
                var emitter = this.context[GRID_CONTEXT_EMITTER];
                emitter.emit(EVENT_GRID.CELL_UPDATE, this.props.gridRowIndexKey, this.props.gridColumnIndexKey, newWidth, this.props.isInHead);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _classnames2,
                _classnames3,
                _this8 = this;

            var _a = this.props,
                _a$TableCell = _a.TableCell,
                TableCell = _a$TableCell === undefined ? _Table.TableCell : _a$TableCell,
                _a$align = _a.align,
                align = _a$align === undefined ? GridCellAlignment.CENTER : _a$align,
                gridRowIndexKey = _a.gridRowIndexKey,
                gridColumnIndexKey = _a.gridColumnIndexKey,
                gridColumnWidth = _a.gridColumnWidth,
                colSpan = _a.colSpan,
                rowSpan = _a.rowSpan,
                restProps = tslib_1.__rest(_a, ["TableCell", "align", "gridRowIndexKey", "gridColumnIndexKey", "gridColumnWidth", "colSpan", "rowSpan"]);
            var style = void 0;
            if (typeof gridColumnWidth !== 'undefined') {
                style = {
                    width: gridColumnWidth + 'px'
                };
            }
            var contentClassName = (0, _classnames5.default)(restProps.theme.gridCell__content, (_classnames2 = {}, _defineProperty(_classnames2, restProps.theme.gridCell__content_left, align === GridCellAlignment.LEFT), _defineProperty(_classnames2, restProps.theme.gridCell__content_center, align === GridCellAlignment.CENTER), _defineProperty(_classnames2, restProps.theme.gridCell__content_right, align === GridCellAlignment.RIGHT), _classnames2));
            var tableCellTheme = Object.assign({}, restProps.theme, { cell: (0, _classnames5.default)(restProps.theme.cell, (_classnames3 = {}, _defineProperty(_classnames3, restProps.theme.cell_left, align === GridCellAlignment.LEFT), _defineProperty(_classnames3, restProps.theme.cell_center, align === GridCellAlignment.CENTER), _defineProperty(_classnames3, restProps.theme.cell_right, align === GridCellAlignment.RIGHT), _classnames3)) });
            return _react2.default.createElement(TableCell, Object.assign({}, restProps, { theme: tableCellTheme }), _react2.default.createElement("span", { style: style, className: restProps.theme.gridCell__placeholder }, _react2.default.createElement("span", { className: contentClassName, ref: function ref(el) {
                    return _this8._content = el;
                } }, restProps.children)));
        }
    }]);

    return RawGridCell;
}(_react2.default.Component);
RawGridCell.contextTypes = CONTEXT_TYPES;
RawGridCell = tslib_1.__decorate([_pure.PURE], RawGridCell);
var Grid = exports.Grid = (0, _withTheme.withTheme)(GRID)(RawGrid);
var GridBody = exports.GridBody = (0, _withTheme.withTheme)(GRID)(RawGridBody);
var GridHead = exports.GridHead = (0, _withTheme.withTheme)(GRID)(RawGridHead);
var GridRow = exports.GridRow = (0, _withTheme.withTheme)(GRID)(RawGridRow);
var GridCell = exports.GridCell = (0, _withTheme.withTheme)(GRID)(RawGridCell);