/// <reference types="react" />
import TPortalProps = ReactOverlays.Portal.TPortalProps;
import { ComponentClass, MouseEventHandler, ReactNode } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
import { ReactRef } from '../../utils/typings';
export declare const POPOVER: symbol;
export declare enum PopoverPlacement {
    Top = "Top",
    Bottom = "Bottom",
    Left = "Left",
    Right = "Right",
}
export declare enum PopoverAlign {
    Top = "Top",
    Bottom = "Bottom",
    Left = "Left",
    Right = "Right",
    Middle = "Middle",
    Center = "Center",
}
export declare type TFullPopoverProps = {
    children: ReactNode;
    isOpened?: boolean;
    closeOnClickAway?: boolean;
    anchor?: ReactRef;
    onMouseDown?: MouseEventHandler<Element>;
    placement: PopoverPlacement;
    align: PopoverAlign;
    container?: TPortalProps['container'];
    onRequestClose?: () => any;
    hasArrow?: boolean;
    theme: {
        container?: string;
        container_hasArrow?: string;
        container_placementTop?: string;
        container_placementBottom?: string;
        container_placementLeft?: string;
        container_placementRight?: string;
        content?: string;
        arrow?: string;
    };
    style?: object;
};
export declare type TPopoverProps = ObjectClean<PartialKeys<TFullPopoverProps, 'theme' | 'align' | 'placement'>>;
export declare const Popover: ComponentClass<TPopoverProps>;
